<template>
    <div class="register-complete-phone section">
        <base-container>
            <base-form
                scope="register-form-code-scope"
                :header="$t('form.inputs.confirm-form.verification_code')"
                class="register-password-form-phone"
                autocomplete="off"
                @sendForm="registerPhoneCode"
            >
                <p>{{ $t('form.6-digit_password') }}
                    <span v-if="data && data.phone"> {{ data.phone }}</span>.
                </p>

                <div class="form-block__wrapper-input">
                    <input
                        :class="['input default', {'is-danger': (errors.has('register-form-code-scope.CODE')) }]"
                        type="text"
                        name="CODE"
                        class="form-block-input"
                        :placeholder="$t('form.inputs.confirm-form.verification_code')"
                        required
                        v-model="code"
                        v-validate="'phoneCode'"
                    >
                    <div
                        v-if="errors.has('register-form-code-scope.CODE')"
                        v-show="code !== ''"
                        class="error-message"
                    >
                        {{ errors.first('CODE', 'register-form-code-scope') }}
                    </div>
                </div>
                <div
                    v-if="apiErrors.message"
                    class="error-message"
                >
                    {{ apiErrors.message }}
                </div>
                <div class="register-complete-phone__repeat-code">
                    <a @click.prevent="sendRepeatCode">
                        {{ $t('form.sms-again') }}
                    </a>
                </div>
                <base-button :text="$t('button.send')" />
            </base-form>
        </base-container>
    </div>
</template>

<script>
import { API_TOKEN, API_PHONE_CONFIRM, API_PHONE_VERIFY } from 'const/api';

export default {
    name: 'registration-confirm-phone',
    props: {
        data: Object
    },
    data() {
        return {
            code: ''
        }
    },
    computed: {
        ...mapState('api', ['apiErrors']),
        ...mapGetters('stateForm', ['statusForm'])
    },
    methods: {
        registerPhoneCode(event) {
            const scope = event.target.dataset['vvScope'];
            this.$validator.validateAll(scope).then((result) => {
                if (result) {
                    this.clearApiErrors();
                    this.changeStatusForm();
                    axios.get(API_TOKEN, { withCredentials: true })
                        .then((response) => {
                            const _token = response.data.token;
                            axios.post(API_PHONE_VERIFY, {
                                _token: response.data.token,
                                code: this.code
                            },
                            {
                                headers: {
                                    'Accept': 'application/json',
                                    'X-Requested-With': 'XMLHttpRequest'
                                },
                                withCredentials: true
                            })
                                .then(() => {
                                    this.$router.push('/profile');
                                    this.setRegistrationPageComponent('registration-form');
                                })
                                .catch((error) => {
                                    this.addApiError(error.response.data);
                                })
                                .finally(() => {
                                    this.changeStatusForm();
                                });
                        })
                        .catch((error) => {
                            console.error(API_TOKEN, error);
                        });

                }
            });
        },
        sendRepeatCode() {
            this.changeStatusForm();
            this.clearApiErrors();
            axios.get(API_TOKEN, { withCredentials: true })
                .then((response) => {
                    axios.post(API_PHONE_CONFIRM, {
                        _token: response.data.token
                    },
                    {
                        headers: {
                            'Accept': 'application/json',
                            'X-Requested-With': 'XMLHttpRequest'
                        },
                        withCredentials: true
                    })
                        .then((response) => {
                            if (response && response.data && response.data.message) {
                                alert(response.data.message);
                            }
                            console.warn('response', response);
                        })
                        .catch((error) => {
                            this.addApiError(error.response.data);
                        })
                        .finally(() => {
                            this.changeStatusForm();
                        });
                })
                .catch((error) => {
                    if (error.response) {
                        console.error(API_TOKEN, error.response);
                    }
                });
        },
        ...mapActions('registration', ['setRegistrationPageComponent']),
        ...mapActions('api', ['clearApiErrors', 'addApiError']),
        ...mapActions('stateForm', ['changeStatusForm'])
    }
};
</script>

<style lang="sass">
    .register-complete-phone
        &__repeat-code
            text-align: center
</style>
